/******************************************************************************
;  *   	@MCU   	   	   	   	 : MC30P6240
;  *   	@Create Date         : 2019.12.27
;  *   	@Author/Corporation  : Martin/SinoMCU
;  *   	@΢֧QQȺ   : 814641858
;  *    @΢ٷ̳       : http://bbs.sinomcu.com/
;  *   	@Copyright           : 2019 SINOMCU Corporation,All Rights Reserved.
;  *----------------------Abstract Description---------------------------------
;  *       	   	   	P16 1msжϷתһ
   	   	   	   	1  P13Ƚ
   	   	   	   	   	   	   	P14Ƚ
   	   	   	   	   	   	   	P13>P14  CMPOF=0;P17=0;
   	   	   	   	   	   	   	P13<P14  CMPOF=1;P17=1;
   	   	   	   	2  VDDѹ(demoѡ3.0V)Ƚ
   	   	   	   	   	   	   	VIR(0.5V)Ƚ
   	   	   	   	   	   	   	VDD>3.0V  CMPOF=0;P17=0;
   	   	   	   	   	   	   	VDD<3.0V  CMPOF=1;P17=1;   	
   	   	   	   	   	   	   	   	   	   	   	   	   	
******************************************************************************/

#include "user.h"


/************************************************
;  *    @Function Name       : CLR_RAM
;  *    @Description         : ʼRAM
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/  
void CLR_RAM(void)
{      	       	
    __asm
           	movai  	0x40
           	movra  	FSR
           	movai  	48
           	movra  	0x07
           	decr   	FSR
           	clrr   	INDF
           	djzr   	0x07
           	goto   	$-3
           	clrr   	0x07
    __endasm;          	
}

/************************************************
;  *    @Function Name       : IO_Init
;  *    @Description         : io 
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/ 
void IO_Init(void)
{
   	P0 = 0x00; 	   	   	   	
   	P1 = 0x00;
   	DDR0 = 0x00;   	//1:input 0:output
   	DDR1 = 0x00;       	   	
   	PUDCON = 0xff;     	//0:Effective 1:invalid
   	PUCON = 0xff;  	//0:Effective 1:invalid 
   	ODCON = 0x00;  	   	//0:  1:© 
}
/************************************************
;  *    @Function Name       : TIMER0_INT_Init
;  *    @Description         : 
;  *    @IN_Parameter        :
;  *    @Return parameter    :
;  ***********************************************/
void TIMER0_INT_Init(void)
{
   	T0CR=0x04;     //ʱΪCPUʱ    ʱ64Ƶ  1ms
   	T0CNT=256-125;
   	T0IE=1;
}
/************************************************
;  *    @Function Name       : CMP_Init
;  *    @Description         : 
;  *    @IN_Parameter        :
;  *    @Return parameter    :
;  ***********************************************/
void CMP_Init(void)
{
   	//1
       //	   	MCR|=0x03; 	   	   	   	//CMPNΪȽ P13
       //    	CMPCR=0x01;	   	   	   	//رCMPж  ΪCMPP P14
       //    	P13PU=0;
       //    	P14PU=0;  
       //    	DDR13=1;  
       //	   	DDR14=1;

   	//2
     	MCR|=0x15; 	   	   	    //ΪVDD ѹ3.0V 
     	CMPCR=0x00;	   	   	   	//رCMPж  ΪVIR 0.5V
}
/************************************************
;  *    @Function Name       : InitSys
;  *    @Description         : ϵͳʼ
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/  
void Sys_Init(void)
{
   	GIE = 0;
   	CLR_RAM();
   	IO_Init();
   	TIMER0_INT_Init();
    CMP_Init();
   	GIE  = 1;        
}
//=================================================================================
void main (void)
{    
   	Sys_Init();
   	while(1)
   	{  	 
   	   	if(CMPOF)
   	   	{
   	   	    P17D=1;
   	   	}else
   	   	{
   	   	    P17D=0;
   	   	}

   	}   
}


/************************************************
;  *    @Function Name       : Interrupt
;  *    @Description         : The interrupt function
;  *    @IN_Parameter          	 :
;  *    @Return parameter      	:
;  ***********************************************/        
void int_isr(void)__interrupt
{
   	__asm
   	   	movra   _abuf
    swapar  _STATUS
    movra   _statusbuf
__endasm;

    if((T0IF)&&(T0IE))
    {
       	T0CNT=256-125;
   	   	P16D=!P16D; 
   	   	T0IF=0;	   	   	  
    }

__asm
       	swapar  _statusbuf
    movra   _STATUS
    swapr   _abuf
    swapar  _abuf
__endasm;
}


